# OpalVideoMediaStream Class Reference

`#include <mediastrm.h>`

Inheritance diagram for OpalVideoMediaStream:

[legend]
Collaboration diagram for OpalVideoMediaStream:
[legend]

## Public Member Functions

Construction
| OpalVideoMediaStream (OpalConnection &conn, const OpalMediaFormat &mediaFormat, unsigned sessionID, PVideoInputDevice *inputDevice, PVideoOutputDevice *outputDevice, bool autoDeleteInput=true, bool autoDeleteOutput=true)
| ~OpalVideoMediaStream ()
Overrides of PChannel class
virtual PBoolean | Open ()
virtual PBoolean | ExecuteCommand (const OpalMediaCommand &command)
virtual PBoolean | ReadData (BYTE *data, PINDEX size, PINDEX &length)
virtual PBoolean | WriteData (const BYTE *data, PINDEX length, PINDEX &written)
virtual PBoolean | IsSynchronous () const
virtual PBoolean | SetDataSize (PINDEX dataSize, PINDEX frameTime)
virtual void | SetVideoInputDevice (PVideoInputDevice *device, bool autoDelete=true)
virtual PVideoInputDevice * | GetVideoInputDevice () const
virtual void | SetVideoOutputDevice (PVideoOutputDevice *device, bool autoDelete=true)
virtual PVideoOutputDevice * | GetVideoOutputDevice () const

## Protected Member Functions

virtual void | InternalClose ()
virtual bool | InternalUpdateMediaFormat (const OpalMediaFormat &newMediaFormat)
bool | InternalAdjustDevices ()

## Protected Attributes

PVideoInputDevice * | m_inputDevice
PVideoOutputDevice * | m_outputDevice
bool | m_autoDeleteInput
bool | m_autoDeleteOutput
PTimeInterval | m_lastGrabTime
bool | m_needKeyFrame
PMutex | m_devicesMutex

## Constructor & Destructor Documentation

OpalVideoMediaStream::OpalVideoMediaStream | ( | OpalConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | PVideoInputDevice * | inputDevice,
|  | PVideoOutputDevice * | outputDevice,
|  | bool | autoDeleteInput = `true`,
|  | bool | autoDeleteOutput = `true` |
| ) |  |  |

Construct a new media stream for channel.

Parameters:

  conn | Connection that owns the stream
  mediaFormat | Media format for stream
  sessionID | Session number for stream
  inputDevice | Device to use for video grabbing
  outputDevice | Device to use for video display
  autoDeleteInput | Automatically delete PVideoInputDevice
  autoDeleteOutput | Automatically delete PVideoOutputDevice

OpalVideoMediaStream::~OpalVideoMediaStream | ( |  | ) |

Delete attached channel if autoDelete enabled.

## Member Function Documentation

virtual PBoolean OpalVideoMediaStream::ExecuteCommand | ( | const OpalMediaCommand & | command | ) | `[virtual]`

Execute the command specified to the transcoder. The commands are highly context sensitive, for example OpalVideoUpdatePicture would only apply to a video transcoder.

The default behaviour checks for video fast update and then passes the command on to the OpalMediaPatch.

Parameters:

  command | Command to execute.

Reimplemented from OpalMediaStream.

virtual PVideoInputDevice* OpalVideoMediaStream::GetVideoInputDevice | ( |  | ) | const`[inline, virtual]`

Get the input device (e.g. for statistics)

virtual PVideoOutputDevice* OpalVideoMediaStream::GetVideoOutputDevice | ( |  | ) | const`[inline, virtual]`

Get the output device (e.g. for statistics)

bool OpalVideoMediaStream::InternalAdjustDevices | ( |  | ) | `[protected]`

virtual void OpalVideoMediaStream::InternalClose | ( |  | ) | `[protected, virtual]`

Close any internal components of the stream. This should be used in preference to overriding the Close() function as it is guaranteed to be called exactly once and avoids race conditions in the shut down sequence of a media stream.

Implements OpalMediaStream.

virtual bool OpalVideoMediaStream::InternalUpdateMediaFormat | ( | const OpalMediaFormat & | newMediaFormat | ) | `[protected, virtual]`

Reimplemented from OpalMediaStream.

virtual PBoolean OpalVideoMediaStream::IsSynchronous | ( |  | ) | const`[virtual]`

Indicate if the media stream is synchronous. Returns true for LID streams.

Implements OpalMediaStream.

virtual PBoolean OpalVideoMediaStream::Open | ( |  | ) | `[virtual]`

Open the media stream.

The default behaviour sets the OpalLineInterfaceDevice format and calls Resume() on the associated OpalMediaPatch thread.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalVideoMediaStream::ReadData | ( | BYTE * | data,
|  | PINDEX | size,
|  | PINDEX & | length |
| ) |  |  | `[virtual]`

Read raw media data from the source media stream. The default behaviour simply calls ReadPacket() on the data portion of the RTP_DataFrame and sets the frames timestamp and marker from the internal member variables of the media stream class.

Parameters:

  data | Data buffer to read to
  size | Size of buffer
  length | Length of data actually read

Reimplemented from OpalMediaStream.

virtual PBoolean OpalVideoMediaStream::SetDataSize | ( | PINDEX | dataSize,
|  | PINDEX | frameTime |
| ) |  |  | `[virtual]`

Override size of frame header is included

Parameters:

  dataSize | New data size (in total)
  frameTime | Individual frame time (if applicable)

Reimplemented from OpalMediaStream.

virtual void OpalVideoMediaStream::SetVideoInputDevice | ( | PVideoInputDevice * | device,
|  | bool | autoDelete = `true` |
| ) |  |  | `[virtual]`

Set the input device

virtual void OpalVideoMediaStream::SetVideoOutputDevice | ( | PVideoOutputDevice * | device,
|  | bool | autoDelete = `true` |
| ) |  |  | `[virtual]`

Set the output device

virtual PBoolean OpalVideoMediaStream::WriteData | ( | const BYTE * | data,
|  | PINDEX | length,
|  | PINDEX & | written |
| ) |  |  | `[virtual]`

Write raw media data to the sink media stream. The default behaviour calls WritePacket() on the data portion of the RTP_DataFrame and and sets the internal timestamp and marker from the member variables of the media stream class.

Parameters:

  data | Data to write
  length | Length of data to read.
  written | Length of data actually written

Reimplemented from OpalMediaStream.

## Field Documentation

bool OpalVideoMediaStream::m_autoDeleteInput `[protected]`

bool OpalVideoMediaStream::m_autoDeleteOutput `[protected]`

PMutex OpalVideoMediaStream::m_devicesMutex `[protected]`

PVideoInputDevice* OpalVideoMediaStream::m_inputDevice `[protected]`

PTimeInterval OpalVideoMediaStream::m_lastGrabTime `[protected]`

bool OpalVideoMediaStream::m_needKeyFrame `[protected]`

PVideoOutputDevice* OpalVideoMediaStream::m_outputDevice `[protected]`

The documentation for this class was generated from the following file:

- mediastrm.h